// ((Lasers * 2) + (Fans * -2) + (Coolant * -14) + Reactor_Power)
// ((0-6 * 2) + (0-5 * -2) + (1 * -14) + Reactor_Power)
// Being the reactor power levels:
// 1: +2    2: +8    3: +11    4: +14

<template>
  <div class="round-box">
    <div>
        <label>Lasers enabled: </label>
        <input type="number" min="0" max="6" v-model="lasers" @change="calculate" />
    </div>
    <div>
        <label>Fans enabled: </label>
        <input type="number" min="0" max="5" v-model="fans" @change="calculate" />
    </div>
    <div>
        <label>Coolant enabled: </label>
        <input type="checkbox" checked="coolant" v-model="coolant" @change="calculate" />
    </div>
    <div>
        <label>Core Power: </label>
        <input type="number" min="1" max="4" v-model="power" @change="calculate" />
    </div>
    <p>Temperature/s: {{temperature}}</p>
  </div>
</template>

<script>
export default {
  name: "Calculator",
  data() {
    return {
      temperature: 0,
      fans: 0,
      lasers: 0,
      coolant: false,
      power: 1
    };
  },
  methods: {
    calculate: function() {
      const powerLevels = {
        1: 2,
        2: 8,
        3: 11,
        4: 14
      };

      if (this.power < 1) this.power = 1; else
      if (this.power > 4) this.power = 4;

      if (this.fans < 0) this.fans = 0; else
      if (this.fans > 5) this.fans = 5;

      if (this.lasers < 0) this.lasers = 0; else
      if (this.lasers > 6) this.lasers = 6;

      const l = Math.min(6, this.lasers);
      const f = Math.min(5, this.fans);
      const ce = Boolean(this.coolant);

      this.temperature = l * 2 + f * -2 + (ce ? -14 : 0) + powerLevels[this.power];
    }
  }
};
</script>

<style>
.round-box {
  background: #214eb3;
  border-radius: 4%;
  margin-right: 70%;
}
</style>
